SystemOrganization addCategory: #Roassal2Spec!

AbstractMorphicAdapter subclass: #MorphicRoassalAdapter
	instanceVariableNames: 'view canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec'!

!MorphicRoassalAdapter commentStamp: '<historical>' prior: 0!
I am bridging RoassalModel and RTView!

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2014 15:07'!
adapt: aComposableModel

	super adapt: aComposableModel.
	
	view := widget.
	canvas := view setUpCanvas.
	widget := canvas buildMorph.
	widget
		setProperty: #model toValue: self;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	self basicApplyScript
	! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2014 14:44'!
applyScript

	self freeCanvas.
	self basicApplyScript! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2014 14:44'!
basicApplyScript

	self model script 
		cull: view 
		cull: canvas.
		
	self widgetDo: [ :w | w startStepping ]! !

!MorphicRoassalAdapter methodsFor: 'as yet unclassified' stamp: 'PeterUhnak 2/28/2015 17:55'!
buildWidget
	^ RTViewForSpec new
		whenLastEventChangedDo: self whenLastEventChangedBlock;
		yourself! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'PeterUhnak 2/28/2015 17:55'!
freeCanvas
	view := self buildWidget.
	canvas := view setUpCanvas.
	widget extent: canvas extent.

	widget canvas: canvas! !

!MorphicRoassalAdapter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/22/2014 14:13'!
view

	^ view! !

!MorphicRoassalAdapter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/22/2014 15:18'!
whenLastEventChangedBlock

	^ [ :evt | self model lastEvent: evt ]! !

!NewValueHolder methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 15:02'!
announcer

	^ announcer! !

RTView subclass: #RTViewForSpec
	instanceVariableNames: 'lastEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec'!

!RTViewForSpec commentStamp: 'BenjaminVanRyseghem 1/22/2014 10:52' prior: 0!
I am a special view used to record registered announcement to propagate them outside of the view to other Spec models!

!RTViewForSpec methodsFor: 'adding' stamp: 'AlexandreBergel 10/6/2014 10:50'!
addElement: anElement

	super addElement: anElement.
	
	anElement announcer subscriptions 
		subscriptionsDo: [ :reg | 
			anElement 
				when: reg announcementClass
				do: [ :ann | lastEvent value: ann ] ]! !

!RTViewForSpec methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 1/22/2014 09:33'!
initialize

	super initialize.

	lastEvent := nil asValueHolder.! !

!RTViewForSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/22/2014 09:34'!
lastEvent
	^ lastEvent value! !

!RTViewForSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/22/2014 09:34'!
lastEvent: anObject
	lastEvent value: anObject! !

!RTViewForSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/22/2014 15:03'!
lastEventSubscriptionsDo: aBlock

	lastEvent announcer subscriptions subscriptionsDo: aBlock! !

!RTViewForSpec methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/22/2014 09:35'!
whenLastEventChangedDo: aBlock

	lastEvent whenChangedDo: aBlock! !

AbstractWidgetModel subclass: #RoassalModel
	instanceVariableNames: 'script lastEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec'!

!RoassalModel commentStamp: '<historical>' prior: 0!
I am a Spec model to embed Roassal2 visualizations!

!RoassalModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/6/2014 13:00'!
defaultSpec
	<spec>
	
	^ #(MorphicRoassalAdapter
		adapt: #(model))! !

!RoassalModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 1/22/2014 15:20'!
initialize

	super initialize.

	script := [ :v :canvas | ] asValueHolder.
	script whenChangedDo: [ :s | self refresh ].
	lastEvent := nil asValueHolder.! !

!RoassalModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/22/2014 15:20'!
lastEvent

	^ lastEvent value! !

!RoassalModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/22/2014 15:20'!
lastEvent: aBlock

	lastEvent value: aBlock! !

!RoassalModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/22/2014 14:20'!
refresh

	self changed: #applyScript with: #()! !

!RoassalModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/6/2014 12:59'!
script

	^ script value! !

!RoassalModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/6/2014 12:59'!
script: aBlock

	script value: aBlock! !

!RoassalModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/22/2014 15:16'!
whenLastEventChangedDo: aBlock

	lastEvent whenChangedDo: aBlock! !

!SubscriptionRegistry methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 10:04'!
subscriptionsDo: aBlock
	| copy |
	
	self protected: [ copy := subscriptions copy ].
	
	copy do: aBlock! !

!TREvent methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 15:29'!
isMouse

	^ false! !

!TRMouseClick methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 15:30'!
isMouse

	^ true! !
